Index: kernel/db/dbitem.php
===================================================================
--- kernel/db/dbitem.php	(revision 12973)
+++ kernel/db/dbitem.php	(working copy)
@@ -222,6 +222,11 @@
 		$this->FieldErrors[$error_field]['pseudo'] = $pseudo;
 
 		if (isset($error_params)) {
+			if (array_key_exists('value', $error_params)) {
+				$this->FieldErrors[$error_field]['value'] = $error_params['value'];
+				unset($error_params['value']);
+			}
+			
 			// additional params, that helps to determine error sources
 			$this->FieldErrors[$error_field]['params'] = $error_params;
 		}
Index: kernel/utility/formatters/date_formatter.php
===================================================================
--- kernel/utility/formatters/date_formatter.php	(revision 12973)
+++ kernel/utility/formatters/date_formatter.php	(working copy)
@@ -307,9 +307,7 @@
 		$format = $options['input_format'];
 		if ($dt_separator) $format = trim($format, $dt_separator);
 
-		$error_field = isset($this->Fields[$field_name]['error_field']) ? $this->Fields[$field_name]['error_field'] : $field_name;
-		$object->FieldErrors[$error_field]['params'] = Array( $this->HumanFormat($format), adodb_date($format) );
-		$object->FieldErrors[$error_field]['value'] = $value;
+		$error_params = Array( $this->HumanFormat($format), adodb_date($format), 'value' => $value );
 
 		$hour = 0;
 		$minute = 0;
@@ -335,7 +333,7 @@
 
 		$holders_mask = '/' . preg_replace('/[a-zA-Z]{1}/i', '([a-zA-Z]{1})', preg_quote($format, '/')) . '/';
 		if (!preg_match($holders_mask, $format, $holders)) {
-			$object->SetError($field_name, 'bad_date_format');
+			$object->SetError($field_name, 'bad_date_format', null, $error_params);
 			return $value;
 		}
 
@@ -345,7 +343,7 @@
 		}
 
 		if (!preg_match($values_mask, $value, $values)) {
-			$object->SetError($field_name, 'bad_date_format');
+			$object->SetError($field_name, 'bad_date_format', null, $error_params);
 			return $value;
 		}
 
@@ -399,12 +397,12 @@
 		//echo "day: $day, month: $month, year: $year, hour: $hour, minute: $minute<br>";
 
 		/*if (!($year >= 1970 && $year <= 2037)) {
-			$object->SetError($field_name, 'bad_date_format');
+			$object->SetError($field_name, 'bad_date_format', null, $error_params);
 			return $value;
 		}*/
 
 		if (!($month >= 1 && $month <= 12)) {
-			$object->SetError($field_name, 'bad_date_format');
+			$object->SetError($field_name, 'bad_date_format', null, $error_params);
 			return $value;
 		}
 
@@ -412,22 +410,22 @@
 		if ($year % 4 == 0) $months_days[2] = 29;
 
 		if (!($day >=1 && $day <= $months_days[$month])) {
-			$object->SetError($field_name, 'bad_date_format');
+			$object->SetError($field_name, 'bad_date_format', null, $error_params);
 			return $value;
 		}
 
 		if (!($hour >=0 && $hour <= 23)) {
-			$object->SetError($field_name, 'bad_date_format');
+			$object->SetError($field_name, 'bad_date_format', null, $error_params);
 			return $value;
 		}
 
 		if (!($minute >=0 && $minute <= 59)) {
-			$object->SetError($field_name, 'bad_date_format');
+			$object->SetError($field_name, 'bad_date_format', null, $error_params);
 			return $value;
 		}
 
 		if (!($second >=0 && $second <= 59)) {
-			$object->SetError($field_name, 'bad_date_format');
+			$object->SetError($field_name, 'bad_date_format', null, $error_params);
 			return $value;
 		}
 
